<?php
$_SESSION['language'] = "de";
// Layout laden
// Layotanpassungen können durch überschreiben der Variablen aus mainlayout_inc.php vorgenommen werden 
include "./02include/mainlayout_inc.php";  
//Systemwerte 
include "./02include/system_inc.php"; 
//Starcatcher Konfiguration
include "./03config/starcatcher.config";  
//Starcatcher Konfiguration
include "./03config/kameramatrix.config";   
//Standortdaten - Location 
include "./03config/location.config";  
//myFunctions 
include "./02include/myfunctions_inc.php";  

// Überschreibungen
$titel2="Aufnahmesteuerung-Parameter&nbsp;&nbsp;";

include "./02include/htmlmain_inc.php";  
include "./02include/kopf_inc.php";

echo "<div class=\"mainbox\">\n";

// ===========================================================
// Inhalt der Seite 
// Ab hier reines HTML - PHP bei Bedarf ein und auschalten
// ===========================================================
?>
<br>
<?php

echo "<table border=\"0\"><tbody>";

// Neue Zeile ---------------------------------------------------------------------------
echo "<tr>";
// Links 
echo "<td width=\"50%\">";
    echo "<h2>$titel2</h2>";
    $shellcmd = "date";
    $ergebnis = trim(@shell_exec($shellcmd));
    echo "aktuelle Systemzeit <div class=\"SystemCode\">".$ergebnis."</div><br>";
echo "</td>";
// Rechts
echo "<td>";
    echo "<h2>&nbsp;</h2>";
    echo "Standort <div class=\"SystemCode\">".$aktuellerStandort." Länge: ".$laengengrad." Breite: ".$breitengrad."</div><br>";
echo "</td>";
echo "</tr>";

// Prüfen ob gerade eine Serie läuft
// Parameterdatei für Übergabe der Pläne
$parameterdatei = "parameter.runtime.php";

// Laden der Parameterdatei aus dem übergebenen Plan wenn nicht gefunden, dann schlafe eine Weile
if ((include $parameterdatei) == TRUE) {  
    if (isset($_GET['doNext']) == "CancelIt" ) {
        include "./02include/cancel_inc.php";
        echo "<tr><td colspan=\"2\">";
        echo "<h2>Aufnahme vom User abgebrochen !</h2>";
        echo "<br>Schade auch! Dann nochmal von vorn!<br><br>";
        echo "<a href=\"./aufnahme.php\" class=\"Button_003\" style=\"color: white; padding:5px 100px;\" >Aufnahmeparameter neu setzen</a>\n";
        echo "</td></tr>";
    }
    else {

    // Neue Zeile ---------------------------------------------------------------------------
    echo "<tr><td colspan=\"2\">";
        echo "<h2>Aufnahme läuft!</h2>";
        echo "Verarbeitungsdatei gefunden, es läuft:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $plaene[$plan] - $plantxt[$plan]<br><br>";
        echo "Startzeit: ".date("d.m.Y H:i:s", $start)."<br><br>";
        if ($kalkende == 0) {echo "Ende: ".date("d.m.Y H:i:s", $ende)."<br><br>"; } else {echo "voraussichtliches Ende: ".date("d.m.Y H:i:s", $kalkende)."<br><br>"; }
        if ($kalkanzahl == 0) {echo "Anzahl Aufnahmen: ".$anzahl."<br><br>"; } else {echo "berechnete voraussichtliche Anzahl Aufnahmen: ".$kalkanzahl."<br><br>"; }
        if ($crtvideo == "true") {echo "Es wird am Serienende ein Video erstellt.<br>&nbsp;<br>";} else {echo "<br>Es wird am Serienende KEIN Video erstellt.<br>&nbsp;<br>";}     
        $username = get_current_user();
        echo "Aktueller Benutzer: $username"."<br><br>";
        echo "<a href=\"./aufnahme.php?doNext=CancelIt\" class=\"Button_003\" style=\"color: white; padding:5px 100px;\" >Aufnahmeserie sofort stoppen !</a>\n";
        echo "<br><br>Aktueller Inhalt der Protokolldatei $logfile";
        $inhalt = file_get_contents($logfile);
        echo "<br><div class=\"SystemCodeBlue\">";
        echo "<br>"; echo nl2br($inhalt); echo "<br>";
        echo "</div>";        
    echo "</td></tr>";
    }

}
else
{

    // Neue Zeile ---------------------------------------------------------------------------

    $displayEingabe = true;

    # Kamera erkennen
    $shellcmd = "gphoto2 --auto-detect";
    $ergebnis=null; $retval=null;
    exec($shellcmd, $ergebnis, $retval);
    
        if ($retval==0) {
        $posusb = strpos($ergebnis[2],"usb:");
        $kameraname = substr($ergebnis[2], 0, $posusb-1);
        $portusb = substr($ergebnis[2], $posusb, -1);
        $kameranameSys = str_replace(' ', '_', trim($kameraname)); 
    }

    if ($kameraname == "") { $kameranameSys = "STANDARD"; };

    if (!isset($KameraProperties[$kameranameSys]) ) {$kameranameSys = "STANDARD"; }; 

    if (isset($_GET['doNext'])) {
    switch ($_GET['doNext']) {
        case 'setKamera':
            include "./02include/setKamera_inc.php"; 
        break;  
        
        case 'setPlan':
            include "./02include/setPlan_inc.php"; 
        break;      

        case 'Testbild':
            include "./02include/showTestbild_inc.php"; 
        break;      

        case 'gio':
            include "./02include/gio_inc.php"; 
        break;   
                
        case 'doit':
            include "./02include/doit_inc.php";
            $displayEingabe = false; 
        break;    
        
        case 'VideoBatch':
            include "./02include/videoBatch_inc.php"; 
        break;
        

    }
}

// nur anzeigen der Eingabefelder, wenn nicht eine Ausführung gestartet wurde

if ($displayEingabe == true) {

    // Trennlinie
    echo "<tr><td colspan=\"2\"><hr><br></td></tr>";

    // Neue Zeile ---------------------------------------------------------------------------
    // Links 
    echo "<tr><td><h3>Kamerawerte</h3></td>";
    // Rechts 
    echo "<td><h3>Aufnahmezeiten</h3></td></tr>";

    // Neue Zeile ---------------------------------------------------------------------------
    echo "<tr>";
    echo "<form>";

    // Links
    echo "<td>";
        makeConfig($kameranameSys, "imageformat");
        echo "<br>";
        makeConfig($kameranameSys, "iso");
        echo "<br>";
        makeConfig($kameranameSys, "shutterspeed");
        echo "<br>";
        makeConfig($kameranameSys, "aperture");
        echo "<br>";

        // Option Uhrzeit mit PC Sysncronisieren
        echo "<input type=\"checkbox\" id=\"$yncpc\" name=\"syncpc\" value=\"now\" />";
        echo "<label for=\"syncpc\">&nbsp;&nbsp;Uhrzeit der Kamera mit dem PC Synchronisieren</label>";
        echo "<br>";

        if (!$kameraname == "") { echo "<br><div class=\"SystemCode\">Kamera (--auto-detect): ".trim($kameraname)."(Sys: ".$kameranameSys.")"."<br>an PORT: ".trim($portusb)."</div>";   } 
            else {   echo "<br><div class=\"SystemCode\">Keine Kamera gefunden oder Gerät nicht verfügbar (Sys: ".$kameranameSys.")<br><br>Hinweis try: gio mount -s gphoto2</div><br><br>";   }

        echo "<br><div class=\"SystemCode\">";
        makeConfig($kameranameSys, "cameramodel");
        makeConfig($kameranameSys, "lensname");
        makeConfig($kameranameSys, "datetime");
        makeConfig($kameranameSys, "batterylevel");
        echo "</div>";
        // GIO Mount funktioniert derzeit nicht aus der Weboberfläche heraus
        // echo "<button class=\"Button_003\" style=\"color: white; padding:5px 70px;\" type=\"submit\" name=\"action\" formaction=\"aufnahme.php?doNext=gio\" formmethod=\"post\">gio mount -s gphoto2</button><br>";

        if ($FTPUpload == true) { echo "<br><div class=\"SystemCode\">Der FTP Upload auf einen externen Webserver ist aktiv.<br>Es wird eine Datei ".$RemoteDateiname." dort abgelegt</div>";   } 
        
    echo "</td>";

    // Rechts
    echo "<td>";
        $akt_date = time(); 
        $akt_date24 = time() + 60*60*24;
        // echo "Es ist: ".date("d.m.Y - H:i:s", $akt_date)."<br>";
        // Astro Werte heute asl Start
        $sun_info = date_sun_info($akt_date, $breitengrad, $laengengrad);
        $startcivil = $sun_info['civil_twilight_end'];
        $startcivilText = date("d.m.Y H:i", $sun_info['civil_twilight_end']);
        $startnautic = $sun_info['nautical_twilight_end'];
        $startnauticText = date("d.m.Y H:i", $sun_info['nautical_twilight_end']);
        $startastro = $sun_info['astronomical_twilight_end'];
        $startastroText = date("d.m.Y H:i", $sun_info['astronomical_twilight_end']);
        // Astro Werte Morgen als Ende
        $sun_info = date_sun_info($akt_date24, $breitengrad, $laengengrad);
        $endecivil = $sun_info['civil_twilight_begin'];
        $endecivilText = date("d.m.Y H:i", $sun_info['civil_twilight_begin']);
        $endenautic = $sun_info['nautical_twilight_begin'];
        $endenauticText = date("d.m.Y H:i", $sun_info['nautical_twilight_begin']);
        $endeastro = $sun_info['astronomical_twilight_begin'];
        $endeastroText = date("d.m.Y H:i", $sun_info['astronomical_twilight_begin']);

        // Tabelle Zeiten
        echo "<table><tr><td style=\"width:75%\">";
            echo "<label for=\"Startzeit\">Startzeit</label><br>";
            echo "<select id=\"Startzeit\" name=\"Startzeit\">";
            echo "<option value=\"".$startcivil."\">".$startcivilText." - bürgerliche Dämmerung</option>\n";  
            echo "<option value=\"".$startnautic."\">".$startnauticText." - nautische Dämmerung</option>\n";
            echo "<option value=\"".$startastro."\" selected>".$startastroText." - astronomische Dämmerung</option>\n";
            echo "</select>";
        echo "</td><td>";
            if (isset($_POST['freeStart']))	{ $formularvalue = date("Y-m-d", $SERfreeStart)."T".date("H:i", $SERfreeStart);	}
            else	{  $formularvalue = date("Y-m-d", time() )."T".date("H:i", time() ); } 
            echo "<label for=\"freeStart\">freie Startzeit</label><br>";
            echo "<input type=\"datetime-local\" value=\"$formularvalue\" name=\"freeStart\">";
        echo "</td></tr><tr><td>";
            echo "<label for=\"Endezeit\">Endezeit</label><br>";
            echo "<select id=\"Endezeit\" name=\"Endezeit\">";
            echo "<option value=\"".$endecivil."\">".$endecivilText." - bürgerliche Dämmerung</option>\n";  
            echo "<option value=\"".$endenautic."\">".$endenauticText." - nautische Dämmerung</option>\n";
            echo "<option value=\"".$endeastro."\" selected>".$endeastroText." - astronomische Dämmerung</option>\n";
            echo "</select>";
        echo "</td><td>";
            if (isset($_POST['freeEnde']))	{ $formularvalue = date("Y-m-d", $SERfreeEnde)."T".date("H:i", $SERfreeEnde);	}
            else	{  $formularvalue = date("Y-m-d", time()+ 60*60*3 )."T".date("H:i", time()+ 60*60*3 ); } 
            echo "<label for=\"freeEnde\">freie Endezeit</label><br>";
            echo "<input type=\"datetime-local\" value=\"$formularvalue\" name=\"freeEnde\">";
        echo "</td></tr></table>";
        
        // Tabelle Anzahlwerte & Objektname
        echo "<br>";
        if ($SERanzahl>0) { if ($SERanzahl>$maxanzahl) {$SERanzahl=$maxanzahl;} $useAnzahl=$SERanzahl;} else {$useAnzahl=$stdanzahl;} 
        if ($SERpause>0) {$usePause=$SERpause;} else {$usePause=$stdpause;} 
        if (!$SERobjektname == '') {$useObjektname = $SERobjektname;} else {$useObjektname = $stdObjektname;} 
      
        echo "<table><tr><td style=\"width:55%\">";
            echo "<label for=\"anzahl\">Anzahl Aufnahmen</label><br>";
            echo "<input style=\"width:200px\" id=\"anzahl\" name=\"anzahl\" type=\"number\" min=\"1\" max=\"$maxanzahl\" step=\"1\" value=\"$useAnzahl\">";
        echo "</td><td>";
            echo "<label for=\"pause\">Pause zwischen zwei Aufnahmen</label><br>";
            echo "<input style=\"width:200px\" id=\"pause\" name=\"pause\" type=\"number\" min=\"1\" max=\"$maxpause\" step=\"1\" value=\"$usePause\">";
        echo "</td></tr>";
        echo "<tr><td colspan=\"2\">";
            echo "<br><label for=\"objektname\">Bezeichnung Ordner Aufnahmeobjekt</label><br>";
            echo "<input style=\"width:380px\" maxlength=\"30\" id=\"objektname\" name=\"objektname\" type=\"text\" value=\"$useObjektname\">";
        echo "</td></tr>";
        echo "<tr><td colspan=\"2\">";
            echo "<br><label for=\"crtvideo\">Video erstellen</label>&nbsp;&nbsp;&nbsp;";
            if ($VideoAktiv == true) {echo "<input type=\"checkbox\" id=\"crtvideo\" name=\"crtvideo\" checked />";} else {echo "<input type=\"checkbox\" id=\"crtvideo\" name=\"crtvideo\" />";}
        echo "</td></tr></table>";

        echo "<br><br>";
        echo "<fieldset>";
        echo "<legend>Kalkulationsart auswählen</legend>";
        if ($SERplanNr>0) {$usePlan=$SERplanNr;} else {$usePlan=$planselect;} 
        for($i = 1; $i < count($plaene)+1; $i++) {
            if($i == $usePlan) {    
                echo "<input type=\"radio\" id=\"$plaene[$i]\" name=\"plan\" value=\"$plaene[$i] --$i\" checked />";
                echo "<label for=\"$plaene[$i]\">$plantxt[$i]</label>";
                echo "<br>";
                } 
            else {
                echo "<input type=\"radio\" id=\"$plaene[$i]\" name=\"plan\" value=\"$plaene[$i] --$i\" />";
                echo "<label for=\"$plaene[$i]\">$plantxt[$i]</label>";
                echo "<br>";
                }
            }
        echo "</fieldset>";

        echo "<br>";
        echo "<div class=\"SystemCode\">Die Kalkulation berücksichtigt die eingestellten Kamerawerte, Anzahl und/oder Pausen. Zusätzlich wird eine Pufferzeit ($pufferzeit Sekunden) berücksichtigt, die aufgrund von Speichervorgängen und USB Transfers erforderlich ist.</div>"; 
        echo "<br><br>";
    echo "</td>";
    // Button Zeile
    echo "</tr><tr><td>";
        echo "<button class=\"Button_003\" style=\"color: white; padding:5px 30px;\" type=\"submit\" name=\"action\" formaction=\"aufnahme.php?doNext=setKamera\" formmethod=\"post\">Werte auf Kamera einstellen</button>";
        echo "&nbsp;&nbsp;&nbsp;&nbsp;<button class=\"Button_003\" style=\"color: white; padding:5px 30px;\" type=\"submit\" name=\"action\" formaction=\"aufnahme.php?doNext=Testbild\" formmethod=\"post\">Testbild machen</button><br>";
    echo "</td><td>";
        echo "<button class=\"Button_003\" style=\"color: white; padding:5px 70px;\" type=\"submit\" name=\"action\" formaction=\"aufnahme.php?doNext=setPlan\" formmethod=\"post\">Plan für Session erstellen</button><br>";
    echo "</td>";

    echo "</form>\n";
    echo "</tr>";

    // Neue Zeile ---------------------------------------------------------------------------
    echo "<tr><td colspan=\"2\">";
        echo "<br><hr><br>StarCatcher Bilderverzeichnisse mit Aufnahmen";
        // Bilderordner im Bilderverzeichnis lesen in ein array
        $PicDir = array_diff(scandir($StarCatcherPictureDir), array('..', '.', 'testbild.jpg'));

        // neue Tabelle für Links zur Videoerstellung
        echo "<table><tbody>";    
            echo "<tr><td colspan=\"4\">&nbsp;</td></tr>"; 
            foreach($PicDir as $DirVideo) 
            {
                $VideoDir = $StarCatcherPictureDir.$DirVideo."/";
                $files = array_diff(scandir($VideoDir), array('..', '.'));
                $Bilder = count($files);
                if (is_dir("$VideoDir")) {
                    echo "<tr>";
                    // Seitenverhältnis eines Orignal Bildes - Arry Index 2, da index erst bei 3 beginnt, weil . .. und Video_Temp ausgeschlossen wurden
                    $bild = $VideoDir.$files[2];  list($origWidth, $origHeight, $type) = getimagesize($bild);
                    echo "<td width=\"300px\"><div class=\"SystemCode\">".$DirVideo." - ($Bilder Bilder)<br>Format: $origWidth x $origHeight<br><br></div></td>"; 
                    echo "<td width=\"300px\"><a href=\"./aufnahme.php?doNext=VideoBatch&bilddir=$DirVideo&breite=$VideoX&hoehe=$VideoY&hz=$PicPerSecond\" class=\"Button_001\" style=\"color: white; padding:2px 20px;\" >Video erstellen (Vorgabe)</a></td>\n"; 
                    echo "<td width=\"300px\"><a href=\"./aufnahme.php?doNext=VideoBatch&bilddir=$DirVideo&breite=$VideoX_FHD&hoehe=$VideoY_FHD&hz=$PicPerSecond_FHD\" class=\"Button_001\" style=\"color: white; padding:2px 20px;\" >Full HD Video erstellen</a></td>\n"; 
                    echo "<td><a href=\"./aufnahme.php?doNext=VideoBatch&bilddir=$DirVideo&breite=$VideoX_SMALL&hoehe=$VideoY_SMALL&hz=$PicPerSecond_SMALL\" class=\"Button_001\" style=\"color: white; padding:2px 20px;\" >HD Video erstellen</a></td>\n"; 
                    echo "</tr>";
                }
            } 
        echo "</tbody></table>";
    echo "</td></tr>"; 

    // Neue Zeile ---------------------------------------------------------------------------
    echo "<tr><td colspan=\"2\">";
        echo "<br><hr><br>StarCatcher Videos<br><br>";
        $Quelldateien = array_diff(scandir($StarCatcherVideoDir), array('..', '.'));
        foreach($Quelldateien as $file)    { echo "<div class=\"SystemCode\">".$file."</div>";  } 
    echo "</td></tr>";

    // Neue Zeile ---------------------------------------------------------------------------
    if ((include "video.runtime.php") == TRUE) {
        $datei = $StarCatcherLogDir.$BildDIR."_CreateVideo.log";
        echo "<tr><td colspan=\"2\">";
        echo "<div class=\"SystemCode\"><br>Es läuft bereits eine Videoerstellung.<br><br></div>";
        echo "Aktuelles Protokoll - ".$datei;
        echo "<div class=\"SystemCode\">";
            $inhalt = file_get_contents($datei);
            echo "<br>"; echo nl2br($inhalt); echo "<br>"; echo "<br></div>";
        echo "</td></tr>";    
    }
    // Neue Zeile ---------------------------------------------------------------------------
    echo "<tr><td colspan=\"2\">";
        echo "<br><hr><br>StarCatcher Verzeichnisse";
        echo "<div class=\"SystemCode\"><br>".$StarCatcherDir."</div>";
        echo "<div class=\"SystemCode\">".$StarCatcherPictureDir."</div>";
        echo "<div class=\"SystemCode\">".$StarCatcherVideoDir."</div>";
        echo "<div class=\"SystemCode\">".$StarCatcherLogDir."</div>";
        echo "<div class=\"SystemCode\">".$wwwpfad."</div>";
    echo "</td></tr>";

    // Neue Zeile ---------------------------------------------------------------------------
    echo "<tr><td colspan=\"2\">";
        echo "<br><hr ><br>StarCatcher Protokolldateien<br><br>";
        $Quelldateien = array_diff(scandir($StarCatcherLogDir), array('..', '.'));
        echo "<table><tbody>";    
            foreach($Quelldateien as $file)    {
                echo "<tr>";
                echo "<td width=\"300px\"><div class=\"SystemCode\">".$file."</div></td>\n";  
                echo "<td width=\"300px\"><a href=\"./aufnahme.php?ViewProtokoll=$StarCatcherLogDir$file\" class=\"Button_001\" style=\"color: white; padding:2px 20px;\" >Protokoll anzeigen</a></td>\n"; 
                echo "</tr>";
            } 
        echo "</tbody></table>";
    echo "</td></tr>";

    // Neue Zeile ---------------------------------------------------------------------------
    if (isset($_GET['ViewProtokoll']) ) {
        $datei = $_GET['ViewProtokoll'];
        echo "<tr><td colspan=\"2\">";
        echo "<br>Angezeigtes Protokoll - ".$datei;
        echo "<div class=\"SystemCodeBlue\">";
            $inhalt = file_get_contents($datei);
            echo "<br>"; echo nl2br($inhalt); echo "<br>"; echo "<br></div>";
        echo "</td></tr>";    
    }



// Ende von Eingabe DisplayTrue
}
// Ende von Verarbeitung läuft
}

echo "</tbody></table>";


    
// ===========================================================
// Ende Inhalt der Seite
// ===========================================================
echo "</div>\n";

// Fusszeile 
if ($dspfuss == true) { echo "<div class=\"spruchbox\" style=\"color:#FFFFFF\">$Spruch</div>\n"; }
if ($dspfuss == true) { echo "<div class=\"copyrightbox\">$fusstext</div>\n"; }

echo "</body>\n";
echo "</html>\n";
?>