<?php

// Layout laden
// Layotanpassungen können durch überschreiben der Variablen aus mainlayout_inc.php vorgenommen werden 
include "./02include/mainlayout_inc.php";  

// Überschreibungen
$titel2="Last Catch&nbsp;&nbsp;";
$refreshTime = "60";

include "./02include/htmlmain_inc.php";  
include "./02include/kopf_inc.php";
include "./03config/starcatcher.config";

echo "<div class=\"mainbox\">\n";

// ===========================================================
// Inhalt der Seite 
// Ab hier reines HTML - PHP bei Bedar fein und auschalten
// ===========================================================
echo "<br><h2>StarCatcher</h2>\n";
echo "Sie sehen das Bild lastcatch.jpg (letzte Aufnahme) - automatische Aktualisierung alle $refreshTime Sekunden - <br>\n";
echo "<br>\n";

// Verzeichnis
$dirpic = "lastcatch.jpg";

// Bild anzeigen

// EXIF Daten lesen
$exiffile = "lastcatch.jpg";
$ifd0 = @exif_read_data($exiffile ,'IFD0' ,0);
$exif = @exif_read_data($exiffile ,'EXIF' ,0);

//ISO-Wert
$iso=$ifd0['ISOSpeedRatings'];

//Belichtungszeit
$belichtungszeit = $ifd0['ExposureTime'];

$pos = strpos($belichtungszeit, '/');
if ($pos === false) {
    $belichtungszeit = $ifd0['ExposureTime'];
} else {
    $zaehler = substr($belichtungszeit, 0, $pos);
	$nenner = substr($belichtungszeit, $pos+1 );
	$bzeit = round($zaehler/$nenner);
	$belichtung = $bzeit." Sekunden ($belichtungszeit)"; 
}

// Aufnahmezeitpunkt
$shottime = $ifd0['DateTime'];
$tag = substr($shottime,8,2);
$monat = substr($shottime,5,2);
$jahr = substr($shottime,0,4);
$zeit = substr($shottime,11,8);
$shottime = "$tag.$monat.$jahr $zeit";

// ENDE EXIF Daten lesen

// Bildinformation ausgeben
echo "<hr><br>";
echo "Belichtung: $belichtung"; 
echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; 
echo "ISO: $iso<br><br>"; 
echo "Aufnahmezeitpunkt: $shottime<br><br>";

// Bild 
echo "<a href=\"$dirpic\" target=\"_blank\"><img class=\"cambild\" src=\"$dirpic\"></a><br>";
echo "<br>";

if ($EXIFpicture == true) { 
    echo "<hr>";
    echo "EXIF Daten";
    echo "<hr><br>";
    $bild = "lastcatch.jpg";
    if (exif_read_data($bild, 'IFD0')) {
    $exif = exif_read_data($bild, 0, true);
    foreach ($exif as $key => $section) {
    foreach ($section as $name => $val) {
    echo "$key.$name: $val<br>\n";
        } 
      }
    }
}
echo "<br>";
// ===========================================================
// Ende Inhalt der Seite
// ===========================================================
echo "</div>\n";

// Fusszeile 
if ($dspfuss == true) { echo "<div class=\"spruchbox\" style=\"color:#FFFFFF\">$Spruch</div>\n"; }
if ($dspfuss == true) { echo "<div class=\"copyrightbox\">$fusstext</div>\n"; }

echo "</body>\n";
echo "</html>\n";