<?php

// ----------------------------------------------------------------------------------------------------
// Dieser Job wird gestartet, wenn ein Plan erstellt und aktiviert wurde 
// ----------------------------------------------------------------------------------------------------

$myPfad01="/var/www/html/StarCatcher/02include";
$myPfad02="/var/www/html/StarCatcher/03config";
$myPfad03="/var/www/html/StarCatcher/";
set_include_path($myPfad01 . PATH_SEPARATOR . $myPfad02. PATH_SEPARATOR . $myPfad03);
/* $weg=get_include_path(); echo "Hallo:".$weg; */  

// Errorhandling - kann bei Bedarf aktiviert werden 
// include "errorhandling_inc.php"; 
// Systemwerte 
include "system_inc.php"; 
// Starcatcher Konfiguration
include "starcatcher.config";   
// Starcatcher Kameramatrix für Bulb Befehle
include "kameramatrix.config";
// My Functions
include "myfunctions_inc.php";   
 
// Parameterdatei für Übergabe der Pläne
$parameterdatei = "parameter.runtime.php";

// Parameterdatei für Übergabe der Pläne - Abruchsteuerung
$abbruchdatei = "cancel.runtime.php";

// Dateifreigeben für alle
$lastcatch = $wwwpfad."lastcatch.jpg";
$shellcmd = "chmod 777 ".$lastcatch; $ergebnis=null; $retval=null; exec($shellcmd, $ergebnis, $retval);

// Laden der Parameterdatei aus dem übergebenen Plan wenn nicht gefunden, dann schlafe eine Weile
if ((include $parameterdatei) == TRUE) {  
    $logtext = "Verarbeitungsdatei gefunden starte $plaene[$plan] - $plantxt[$plan]";
    writeLog($logfile, $logtext); 
    $logtext = "Parameter: Plan: $plan - Start: $start - Ende: $ende - Anzahl: $anzahl - Pause: $pause - BULB: $bulb - BULB Sekunden: $bulbsec";
    writeLog($logfile, $logtext); 

    // Für dei Bulbsekunden das "s" ergänzem
    $bulbsec = $bulbsec."s";
    
    // Erst ab der Anfangszeit starten
    time_sleep_until($start);

    // Kamera ermitteln
    $kameraname ="";
    $shellcmd = "gphoto2 --auto-detect"; $ergebnis=null; $retval=null; exec($shellcmd, $ergebnis, $retval);

    if ($retval==0) {
        $posusb = strpos($ergebnis[2],"usb:");
        $kameraname = substr($ergebnis[2], 0, $posusb-1);
        $portusb = substr($ergebnis[2], $posusb, -1);
        $kameranameSys = str_replace(' ', '_', trim($kameraname)); 
    }

    // Wenn keine Kamera gefunden, dann Standard
    if ($kameraname == "") { $kameranameSys = "STANDARD"; };
    // Wenn für die gefunden Kamera kein spezielles BULB Kommando hinterlegt ist, dann STANDARD
    if (!isset($KameraBulbCMD[$kameranameSys]) ) {$kameranameSys = "STANDARD"; }; 

    
    // Schleife bis zur Endezeit - kann aber aufgrund der Anzahl abgebrochen werden
    $i = 0;
    while (time() < $ende) {

        if ( file_exists($wwwpfad.$abbruchdatei) == TRUE) { $ende=time();  $dltFile = $wwwpfad.$abbruchdatei; unlink($dltFile); 
            $logtext = "Aufnahmeserie wird nach Useranforderung abgebrochen ! "; writeLog($logfile, $logtext); break; }
        
        $i ++;
        $Aufnahmezeitpunkt = date("Ymd-His", time());
        $PrintAufnahmezeitpunkt = date("d.m.Y - H:i:s", time());
        $dateiname = $outputDir.$Aufnahmezeitpunkt."_$i.jpg";
        
        // Foto machen
        if ($bulb == 0) 
            { $shellcmd = "gphoto2 --capture-image-and-download --filename ".$dateiname; }
        else 
            { $shellcmd = $KameraBulbCMD[$kameranameSys];
            // im CMD müssen die Bulbsekunden und der Dateiname eingefügt werden
            $shellcmd = str_replace('###bulbsec', $bulbsec, $shellcmd);
            $shellcmd = str_replace('###dateiname', $dateiname, $shellcmd);
            }

        // Auslösen mit vorher erstelltem Befehl
        $ergebnis=null; $retval=null;exec($shellcmd, $ergebnis, $retval);
        if (file_exists($dateiname)) {  
            $logtext = "Foto $dateiname aufgenommen"; writeLog($logfile, $logtext); 
            makeOverlay($dateiname,$PrintAufnahmezeitpunkt);
            }
            else 
            { $logtext = "Foto $dateiname nicht erstellt oder gefunden - Kameraproblem?"; writeLog($logfile, $logtext); }    

        // auf Webserver kopieren
        unlink($lastcatch);
		if (!copy($dateiname, $lastcatch)) { $logtext = "Das Kopieren von $dateiname auf den Webserver schlug fehl"; writeLog($logfile, $logtext); } 
            else { $logtext = "Foto $dateiname auf Webserver als lastcatch.jpg kopiert"; writeLog($logfile, $logtext); }

        // FTP Übertragung an Webserver wenn aktiv
        if ($FTPUpload == true) {
            // Verbindung herstellen
            $ftp_verbindung = ftp_connect($RemoteHost);
            if (!$ftp_verbindung == true) { $logtext = "Keine Verbindung zum FTP Serer: $RemoteHost "; writeLog($logfile, $logtext); } 
                else {
                    // Login
                    $ftp_anmeldung = ftp_login($ftp_verbindung, $RemoteUser, $RemotePasswort);
                    if (!$ftp_anmeldung == true) { $logtext = "Anmeldung am FTP Serer fehlgeschlagen: $RemoteHost "; writeLog($logfile, $logtext); } 
                    else
                    { $logtext = "Anmeldung am FTP Serer erfolgreich: $RemoteHost "; writeLog($logfile, $logtext); } 
                    // turn passive mode on
                    ftp_pasv($ftp_verbindung, true);
                    // Time Limit für Script LAufzeit auf unbegrenzt
                    // set_time_limit(0);
                    // Datei hochladen
                        if (ftp_put($ftp_verbindung, $RemoteDateiname, $dateiname, FTP_BINARY))
                        { $logtext = "Foto $dateiname auf FTP-Server als $RemoteDateiname hochgeladen"; writeLog($logfile, $logtext); }
                        else
                        { $logtext = "Fehler: Foto $dateiname nicht auf FTP-Server als $RemoteDateiname hochgeladen"; writeLog($logfile, $logtext); }
                    // Verbindung schließen
                    ftp_close($ftp_verbindung);
                    }   
        }

        // prüfen ob eine vorgegeben Anzahl an Bildern erreicht wurde, dann Schleife verlassen
        if ($i == $anzahl) { 
            $logtext = "Anzahl von $anzahl Fotos aufgenommen, Plan wird beendet.";         writeLog($logfile, $logtext); 
            break; 
            }
        // Pause zwichen zwei Bildern
        sleep($pause);
        }

    // Video erstellen, wenn angefordert
    if ($crtvideo == true) {
        // Eine Parameterdatei anlegen für die Übergabe der Parameter an video.php
        $ausgabedatei = "video.runtime.php";
        // Anfang
        $PHP_parsing = "<?php\n";
        file_put_contents($ausgabedatei, $PHP_parsing);
        // Variablen
        $intext = "$"."BildDIR=\"".$saveordner."\";\n";
        file_put_contents($ausgabedatei, $intext, FILE_APPEND);
        $intext = "$"."VideoBreite=".$VideoX.";\n";
        file_put_contents($ausgabedatei, $intext, FILE_APPEND);
        $intext = "$"."VideoHoehe=".$VideoY.";\n";
        file_put_contents($ausgabedatei, $intext, FILE_APPEND);
        $intext = "$"."hz=".$PicPerSecond.";\n";
        file_put_contents($ausgabedatei, $intext, FILE_APPEND);

        $PHP_parsing = "?>";
        file_put_contents($ausgabedatei, $PHP_parsing, FILE_APPEND);

        $logtext = "Datei $ausgabedatei für die Erstellung des Videos angelegt.";         writeLog($logfile, $logtext); 

        // Dateifreigeben für alle
        $shellcmd = "chmod 777 ".$ausgabedatei; $ergebnis=null; $retval=null; exec($shellcmd, $ergebnis, $retval);
        
        // Den Job starten, aber nicht auf das Ende warten - Batch Verarbeitung wird durch & nach dem Befehl erzeungen im Shell Kommando
        // Die Ausgabe des Programms muss an null umgeleitet werden, sonst wartet das aufrufende PHP auf beendigung und die Ausgabe
        $shellcmd = "/usr/bin/php /var/www/html/StarCatcher/video.php"." > /dev/null 2>&1 &"; $ergebnis=null; $retval=null; exec($shellcmd, $ergebnis, $retval);

        $logtext = "Videoerstellung gestartet (Batch): $shellcmd";         writeLog($logfile, $logtext); 

    }
    else {
        $logtext = "Videoerstellung nicht angefordert.";         writeLog($logfile, $logtext); 
    }
    
    //Parameter Datei löschen, da Plan beendet
    $dltFile = $wwwpfad.$parameterdatei;
    unlink($dltFile);
    $logtext = "Parameterdatei $parameterdatei gelöscht da Plan abgearbeitet.";    writeLog($logfile, $logtext); 
    }

    else {
    $logtext = "Parameterdatei $parameterdatei nicht gefunden, keine Verarbeitung möglich!";
    writeLog($logfile, $logtext);
    }